#include <hmg.ch>


* --------------------------------------------
PROCEDURE Einstellungen()
* --------------------------------------------

   SELECT CONFIG

   GO TOP
   
   lPrinterWahl   := CONFIG->PRINT_WAHL
   lPrintVorschau := CONFIG->PRINT_PREV
   lAutoBackup   := CONFIG->AUTOBACKUP

   
   DEFINE WINDOW Window_Einstellungen ;
      AT 0,0 ;
      WIDTH 500 HEIGHT 300 ;
      TITLE "Allgemeine Programm-Einstellungen" ;
      MODAL
      
      ON KEY ESCAPE ACTION Window_Einstellungen.Release
 
* --------------------------------------------------
 
      @ 020, 020 IMAGE Img_EinstellPrinter ; 
               PARENT Window_Ausgabenerfassung ; 
               PICTURE "Printer" ;
               WIDTH 32 ; 
               HEIGHT 32          
            
      @ 025, 060 LABEL Lbl_Printer ;
				VALUE 'Drucker:' ;
				WIDTH 150;
				FONT "ARIAL" SIZE 10 BOLD


		DEFINE CHECKBOX cbx_PrinterAuswahl
			ROW	20
			COL	160
			CAPTION '- Gerte-Auswahl' 
         WIDTH 150
			TOOLTIP 'Einen anderen als den Standarddrucker whlbar machen' 
			ONCHANGE Set_PrintSettings()
         FONTNAME "ARIAL"
         FONTSIZE 10 
         FONTBOLD .T.
		END CHECKBOX
      
		DEFINE CHECKBOX cbx_PrintVorschau
			ROW	20
			COL	320
			CAPTION '- mit Vorschau' 
         WIDTH 150
			TOOLTIP 'Vor dem Ausdruck Seitenansicht anzeigen' 
			ONCHANGE Set_PrintSettings()
         FONTNAME "ARIAL"
         FONTSIZE 10 
         FONTBOLD .T.
		END CHECKBOX
      
* --------------------------------------------------
 
      @ 060, 020 IMAGE Img_EinstellBackup ; 
               PARENT Window_Ausgabenerfassung ; 
               PICTURE "Backup" ;
               WIDTH 32 ; 
               HEIGHT 32          
            
      @ 065, 060 LABEL Lbl_Backup ;
				VALUE 'Backup:' ;
				WIDTH 150;
				FONT "ARIAL" SIZE 10 BOLD


		DEFINE CHECKBOX cbx_EinstellBackup
			ROW	60
			COL	160
			CAPTION '- Automatisches Backup bei Programmstart' 
         WIDTH 300
			TOOLTIP 'Sicherheitskopien der Datenbanken in einem Unterverzeichnis anlegen' 
			ONCHANGE Set_BackupSettings()
         FONTNAME "ARIAL"
         FONTSIZE 10 
         FONTBOLD .T.
		END CHECKBOX
      
* --------------------------------------------------
      
      @ 220, 160 BUTTON Btn_EinstellSave ;
				CAPTION 'Daten speichern' ;
				PICTURE "Save" LEFT ;
				ACTION Window_Einstellungen.Release ;
				ToolTip "Aktuelle Daten speichern und Fenster schlieen";
				WIDTH 200 ;
				HEIGHT 40 ;
				FONT "ARIAL" SIZE 10 BOLD 

      
    END WINDOW 
   
   Window_Einstellungen.cbx_PrinterAuswahl.value   := lPrinterWahl
   Window_Einstellungen.cbx_PrintVorschau.value   := lPrintVorschau
   Window_Einstellungen.cbx_EinstellBackup.value   := lAutoBackup
   
   Window_Einstellungen.Center

   Window_Einstellungen.Activate
    
RETURN 

*-----------------------------------
FUNCTION Set_PrintSettings()
*-----------------------------------
   CONFIG->PRINT_WAHL   := Window_Einstellungen.cbx_PrinterAuswahl.value
   CONFIG->PRINT_PREV   := Window_Einstellungen.cbx_PrintVorschau.value
RETURN NIL


*-----------------------------------
FUNCTION Set_BackupSettings()
*-----------------------------------
   CONFIG->AutoBackup   := Window_Einstellungen.cbx_EinstellBackup.value
    
RETURN NIL



* --------------------------------------------
PROCEDURE Define_MediaFormat()
* --------------------------------------------

   SELECT LABEL
   
   DEFINE WINDOW Window_BrowseLabel ;
      AT 0,0 ;
      WIDTH 900 HEIGHT 520 ;
      TITLE "Festlegung der Cassetten-Formate" ;
      MODAL 
      
      ON KEY ESCAPE ACTION Window_BrowseLabel.Release

      DEFINE TOOLBAR ToolBar_2 BUTTONSIZE 50, 15 BORDER BOLD
      
			BUTTON Tool_LabelNeu       ;
				CAPTION 'Datensatz hinzufgen' ;
				ACTION 	( Window_BrowseLabel.grd_BrowseLabel.Append ) ;
				ToolTip "Neuen Datensatz erstellen" ;
            SEPARATOR
            
			BUTTON Tool_LabelLoe       ;
				CAPTION 'Datensatz lschen' ;
				ACTION 	( Window_BrowseLabel.grd_BrowseLabel.Delete, Window_BrowseLabel.grd_BrowseLabel.Save ) ;
				ToolTip "Aktuellen Datensatz lschen" ;
            SEPARATOR
            
			BUTTON Tool_LabelSave       ;
				CAPTION 'nderungen speichern' ;
				ACTION Save_MediaFormat() ;
            ToolTip "nderungen bernehmen -> Fenster schlieen mit ESC-Taste"
            
		END TOOLBAR

   
      aCtrl_1 := {'TEXTBOX','CHARACTER'}
      aCtrl_2 := {'TEXTBOX','NUMERIC','9999'}
      aCtrl_3 := {'TEXTBOX','NUMERIC','9999'}
      aCtrl_4 := {'TEXTBOX','NUMERIC','9999'}
      aCtrl_5 := {'TEXTBOX','NUMERIC','9999'}
      aCtrl_6 := {'TEXTBOX','NUMERIC','999'}
      aCtrl_7 := {'TEXTBOX','NUMERIC','999'}
      aCtrl_8 := {'TEXTBOX','NUMERIC','9999'}

      DEFINE GRID grd_BrowseLabel
         ROW 060
         COL 040
         WIDTH 820
         HEIGHT 400 
         FONTNAME "Arial" 
         FONTSIZE 9
			ROWSOURCE "LABEL" 
         HEADERS      { 'Cass.-Format','Breite(mm)','Hoehe(mm)','Beschriftungsfeld','Lasche(mm)','Beschr.(Zeichen)','Text (Zeichen)','Zeilenabstand' }    
         COLUMNFIELDS {   'Format'   ,'Breite_mm' ,'Hoehe_mm' ,  'Feld_1_mm'   , 'Lasche_mm' ,   'Titel_Char'    ,    'Text_Char'    ,  'Abstand_mm'}  
         WIDTHS       {     100    ,   100   ,   100   ,      110     ,    100    ,      100        ,       100       ,   100     }   
			COLUMNCONTROLS { aCtrl_1 , aCtrl_2 , aCtrl_3 , aCtrl_4 , aCtrl_5 , aCtrl_6 , aCtrl_7 , aCtrl_8 }          
         JUSTIFY { GRID_JTFY_LEFT, GRID_JTFY_CENTER, GRID_JTFY_CENTER, GRID_JTFY_CENTER, GRID_JTFY_CENTER, GRID_JTFY_CENTER, GRID_JTFY_CENTER, GRID_JTFY_CENTER }
         ALLOWEDIT .T.
         ALLOWAPPEND .T.
         ALLOWDELETE .T.
      END GRID   
    
    END WINDOW 
   
   Window_BrowseLabel.Center

   Window_BrowseLabel.Activate
    
RETURN 


*------------------------------
FUNCTION Save_MediaFormat()
*------------------------------

   Window_BrowseLabel.grd_BrowseLabel.Save
   
   SELECT Label
   SORT ON Format TO TEMP
   USE TEMP
   COPY TO Label
   USE Label
   
   LOCATE FOR EMPTY(Label->FORMAT)
   
   IF .NOT.FOUND()
    MSGINFO("Die Liste enthlt keine Leerzeile !" +CRLF+CRLF+ "--> Leerzeile wird eingefgt !","Save_Label()")
    Label->(DbAppend())
   ELSE
     Window_BrowseLabel.Release
   ENDIF
   
RETURN NIL


