#include <minigui.ch>
#include <hmg.ch>

DECLARE WINDOW VideoManager


*-------------------------
FUNCTION InitDatabases()
*-------------------------

	CLOSE DATABASES
	
* ---------
  
   IF FILE("VIDEOS.DBF")	// Video- und Medien-Datenbank
      SELECT  1
      USE VIDEOS EXCLUSIVE
   
      IF EOF()
         APPEND BLANK
      ENDIF
      
      IF .NOT. FILE("LFD_NR.NTX")
         INDEX ON STR(LFD_NR) + DTOS(DATUM) TO LFD_NR  
       *  INDEX ON LFD_NR TO LFD_NR
      ENDIF
      IF .NOT. FILE("CASSETTE.NTX")
         INDEX ON CASSETTE TO CASSETTE
      ENDIF
      IF .NOT. FILE("AUFN_DAT.NTX")
         INDEX ON DtoS(DATUM) TO AUFN_DAT
      ENDIF
      IF .NOT. FILE("QUELLSZENE.NTX")
         INDEX ON QUELLSZENE TO QUELLSZENE
      ENDIF
      IF .NOT. FILE("VID_PROJEKT.NTX")
         INDEX ON PROJEKT TO VID_PROJEKT
      ENDIF
      IF .NOT. FILE("VID_TITEL.NTX")
         INDEX ON TITEL TO VID_TITEL
      ENDIF
  
      Vid_Anz := VIDEOS->(LASTREC() )
      
      SET INDEX TO LFD_NR, CASSETTE, AUFN_DAT, QUELLSZENE, VID_PROJEKT, VID_TITEL
      SET ORDER TO 1
      
      GO BOTTOM 
      DBSKIP(-30)
     	Vid_AktRec = VIDEOS->(RECNO() )
	  
   ELSE
      MSGINFO("Datenbankdatei fehlt !","VIDEOS.DBF","InitDatabases()")
      QUIT
   ENDIF
   
* ------ 

   IF FILE("LABEL.DBF")	// Datenbank der Cassetten-Abmessungen
      SELECT  2
      USE LABEL EXCLUSIVE
   
      IF EOF()
         APPEND BLANK
      ENDIF
  
   ELSE
      MSGINFO("Datenbankdatei fehlt !","LABEL.DBF","InitDatabases()")
      QUIT
   ENDIF

* ------ 

   IF FILE("FILTER.DBF")	// Datenbank der Cassetten-Abmessungen
      SELECT  3
      USE FILTER EXCLUSIVE
   
      IF EOF()
         APPEND BLANK
      ENDIF
  
   ELSE
      MSGINFO("Datenbankdatei fehlt !","FILTER.DBF","InitDatabases()")
      QUIT
   ENDIF
   
* ------ 

   IF FILE("CONFIG.DBF")	// Datenbank mit den Programm-Settings
      SELECT  4
      USE CONFIG EXCLUSIVE
   
      IF EOF()
         APPEND BLANK
      ENDIF
        GO TOP
        
      lPrinterWahl   := CONFIG->PRINT_WAHL
      lPrintVorschau := CONFIG->PRINT_PREV
      lAutoBackup    := CONFIG->AUTOBACKUP

   ELSE
      MSGINFO("Datenbankdatei fehlt !","CONFIG.DBF","InitDatabases()")
      QUIT
   ENDIF
   
   * -----------------------
   IF lAutoBackup
    BACKUP()
   ENDIF
   * -----------------------

RETURN NIL   
   
   
*-------------------------------
FUNCTION SortVideo(nSortVar)
*-------------------------------
IF TestModus
 MSGINFO("HEADCLICK: nSortVar = " + STR(nSortVar),"SortVideo(nSortVar)")
ENDIF

   SELECT VIDEOS
   
   SET ORDER TO nSortVar
   
   VideoManager.Brs_VideoListe.Refresh

  RETURN .T.


*---------------------------
FUNCTION DateiPflege()
*---------------------------

   CLOSE ALL
   
   Erase LFD_NR.ntx	// -- Index-Dateien von VIDEOS lschen
   Erase CASSETTE.ntx
   Erase AUFN_DAT.ntx
   ERASE QUELLSZENE.ntx
   ERASE VID_PROJEKT.ntx
   ERASE VID_TITEL.ntx 
 
   SELECT 1
   USE VIDEOS EXCLUSIVE
   SORT ON VIDEOS->LFD_NR TO TEMP	   FOR .NOT. DELETED() //  physikalisch sortieren
   USE TEMP EXCLUSIVE
   COPY TO VIDEOS
   USE

   SELECT 3
   USE FILTER EXCLUSIVE
   ZAP
   PACK
   APPEND BLANK      // Inhalte lschen, nur ein Datensatz !
   USE

   
   
   CLOSE ALL
   
   InitDatabases()
   
   
	Vid_Anz := VIDEOS->(LASTREC() )

   
	MSGINFO("Dateipflege abgeschlossen !!", "DateiPflege()" )

 
RETURN NIL


*-------------------------
FUNCTION Backup()
*-------------------------
      backup_dir  := GetStartUpFolder()
      backup_date  := DTOS(DATE())
      backup_day  := SUBSTR(backup_date,1,4)+'-'+SUBSTR(backup_date,5,2)+'-'+SUBSTR(backup_date,7,2)+'_'
      backup_time := SUBSTR(TIME(), 1, 2)+SUBSTR(TIME(), 4, 2)+SUBSTR(TIME(), 7, 2)
      backup_path := backup_dir +'\'+ backup_day + backup_time +'\'
      
      MakeDir( backup_path )  // Backup-Verzeichnis anlegen
      
      SELECT VIDEOS
      sBackupFile   := backup_path + "VIDEOS"
      COPY TO &sBackupFile

      SELECT LABEL
      sBackupFile   := backup_path + "LABEL"
      COPY TO &sBackupFile
      
      MSGINFO("Sicherungskopien angelegt im Verzeichnis:" +CRLF+CRLF+ backup_path,"Backup()")

RETURN NIL



*-------------------------------
FUNCTION CountMedia()
*-------------------------------

SELECT VIDEOS

v_anz_1 = 1
v_anz_2 = 0
v_anz_3 = 0

SET ORDER TO 1	&& Index auf Cassetten-Nr

Go TOP

c_nr = lfd_nr

DO WHILE .NOT. EOF()
 
 IF lfd_nr # c_nr		&& -- Neue Cassette ?
  c_nr 		= lfd_nr
  v_anz_1	= v_anz_1 + 1
 ENDIF
 
 v_anz_2 	= v_anz_2 + 1 	&&-- neuer Datensatz !
 
 IF .NOT. EMPTY(TITEL)		&&-- ist Video-Clipp vorhanden ?
  v_anz_3 	= v_anz_3 + 1 
 ENDIF

 SKIP
ENDDO


   MSGINFO(CRLF+ "Anzahl Quell-Medien:" + STR(v_anz_1) +CRLF+CRLF+ "Anzahl Original-Szenen:" + STR(v_anz_2) +CRLF+CRLF+ "Anzahl Video-Clips:" + STR(v_anz_3),"Medien-Infos ..")

RETURN



*-------------------------
FUNCTION Create_Record()
*-------------------------
   SortVideo(1)   // Sortieren nach Lfd_Nr
   Go BOTTOM
   
   last_nr		   :=	VIDEOS->LFD_NR
   last_cass	   :=	VIDEOS->Cassette
   last_date	   :=	VIDEOS->DATUM
   last_proj	   :=	VIDEOS->PROJEKT
   last_format	:=	VIDEOS->FORMAT

   APPEND BLANK
   VIDEOS->FORMAT  := last_format	
   IF last_nr < 999
	  last_nr := last_nr + 1
   ENDIF
   VIDEOS->LFD_NR    := last_nr

   VIDEO_GUI()
   
RETURN NIL


*-------------------------
FUNCTION Delete_Record()
*-------------------------
   SELECT VIDEOS
   CassNo := ALLTRIM(STR(LFd_Nr))
   txt_1 := 'Den Datensatz von Cassette ' + CassNo +':' 
   txt_2 := DTOC(Datum)+ ' - ' + ALLTRIM(Quellszene)
   
	If MsgYesNo( txt_1 +CRLF+CRLF+ txt_2 +CRLF+CRLF+ 'wirklich lschen ?')
		Delete
		PACK
      
      GO TOP
      VideoManager.Brs_VideoListe.Refresh

      GO BOTTOM 
    *  DBSKIP(-30)
      
      VideoManager.Brs_VideoListe.Refresh
      
	Endif

RETURN NIL


****************************
FUNCTION Ask_VIDEO_Dupli()
****************************
   SELECT VIDEOS
   CassNo := ALLTRIM(STR(LFd_Nr))
   txt_1 := 'Einen weiteren Szenen-Datensatz fr'
   txt_2 := 'Video-Cassette No. ' + CassNo 
   txt_3 := VIDEOS->Cassette
   
 If MsgYesNo( txt_1 +CRLF+CRLF+ txt_2 + CRLF+ txt_3 +CRLF+CRLF+ 'wirklich DUPLIZIEREN ?')
   last_nr		=	VIDEOS->LFD_NR
   last_cass	=	VIDEOS->Cassette
   last_date	=	VIDEOS->DATUM
   last_proj	=	VIDEOS->PROJEKT
   last_format	=	VIDEOS->FORMAT
   last_szene  = 	'?? --  Original-Szene  -- ??'		&&-- Quell-Szene
   last_clip   = 	'?? -- Titel Video-Clip -- ??'		&&-- Video-Clip Titel

   APPEND BLANK
   VIDEOS->LFD_NR 		:= last_nr		   &&-- letzte eingegebene Cassetten-Nr.
   VIDEOS->CASSETTE  	:= last_cass		&&-- Cassetten-Bezeichnung
   VIDEOS->DATUM  		:= last_date		&&-- Datum der letzten Original-Szene
   VIDEOS->PROJEKT 	   := last_proj	 	&&-- Projekt-Name
   VIDEOS->FORMAT 		:= last_format	&&-- zuletzt verwendetes Medien-Format
   VIDEOS->QUELLSZENE 	:= last_szene		&&-- Dummy-Text
   VIDEOS->TITEL     	:= last_clip		&&-- Dummy-Text

   VIDEO_GUI()
   
 ENDIF

 
*-------------------------------
FUNCTION TabChanged()
*-------------------------------

Actual_Tab := VideoManager.Tab_VideoManager.Value

	
	DO CASE
   
	 CASE Actual_Tab	== 1	// Medien-bersicht
    
      VideoManager.Brs_VideoListe.Value := Vid_AktRec
      
      VideoManager.Tool_01.Enabled  := .T.   // Neu
      VideoManager.Tool_02.Enabled  := .T.   // Lsch
      VideoManager.Tool_03.Enabled  := .T.   // Filter
      VideoManager.Tool_04.Enabled  := .T.   // Freigabe
      VideoManager.Tool_05.Enabled  := .T.   // Bearb
      VideoManager.Tool_06.Enabled  := .T.   // Dupli
      VideoManager.Tool_07.Enabled  := .T.   // Label drucken
      VideoManager.Tool_08.Enabled  := .T.   // Liste drucken

	 CASE Actual_Tab	== 2	// Tree-Ansicht
    
      Vid_AktRec  := VideoManager.Brs_VideoListe.Value
      
      VideoManager.Tool_01.Enabled  := .F.   // Neu
      VideoManager.Tool_02.Enabled  := .F.   // Lsch
      VideoManager.Tool_03.Enabled  := .F.   // Filter
      VideoManager.Tool_04.Enabled  := .F.   // Freigabe
      VideoManager.Tool_05.Enabled  := .F.   // Bearb
      VideoManager.Tool_06.Enabled  := .F.   // Dupli
      VideoManager.Tool_07.Enabled  := .T.   // Label drucken
      VideoManager.Tool_08.Enabled  := .F.   // Liste drucken

      
      CREATE_TREE(Vid_AktRec)
    
	 OTHERWISE
    
	ENDCASE


RETURN NIL

 
*-------------------------------
FUNCTION Print_SzenenListe()
*-------------------------------
 
   SELECT VIDEOS
   SortVideo(1)   // Sortieren nach Lfd_Nr
   Go TOP


  	lPrintAccept   := PreparePrinter()

	If lPrintAccept == .T.
         LOAD REPORT Print_SzenenListe
			EXECUTE REPORT Print_SzenenListe PREVIEW  // ... und Vorschau
	EndIf

 
 RETURN NIL
 

*----------------------------
FUNCTION PreparePrinter()
*----------------------------

 *  lPrinterWahl   := CONFIG->PRINT_WAHL
 *  lPrintVorschau := CONFIG->PRINT_PREV
   
   IF lPrinterWahl == .T.        // mit Drucker-Auswahl
      IF lPrintVorschau == .T.      
         SELECT PRINTER DIALOG TO lPrintAccept PREVIEW		// mit Vorschau
      ELSE                       
         SELECT PRINTER DIALOG TO lPrintAccept             // ohne Vorschau
      ENDIF   
   ELSE                    // ohne Drucker-Auswahl
      IF lPrintVorschau == .T.   
      	SELECT PRINTER DEFAULT Preview ;      // mit Vorschau
			ORIENTATION	PRINTER_ORIENT_PORTRAIT ;
			PAPERSIZE	PRINTER_PAPER_A4 ;
			QUALITY		PRINTER_RES_MEDIUM 
      ELSE                    
      	SELECT PRINTER DEFAULT  ;            // ohne Vorschau
			ORIENTATION	PRINTER_ORIENT_PORTRAIT ;
			PAPERSIZE	PRINTER_PAPER_A4 ;
			QUALITY		PRINTER_RES_MEDIUM 
      ENDIF   
      lPrintAccept   := .T.   // kein Abbruch mglich
   ENDIF
   
RETURN lPrintAccept
