#include <hmg.ch>


DECLARE WINDOW VideoManager


*-------------------------
FUNCTION VIDEO_GUI()
*-------------------------
  
   DEFINE WINDOW Window_EditVideo ;
      AT 0,0 ;
      WIDTH 700 HEIGHT 340 ;
      TITLE "Medien-Datensatz" ;
      MODAL 
      
      ON KEY ESCAPE ACTION (Save_MediaData(), Window_EditVideo.Release, VideoManager.Brs_VideoListe.Refresh)
      
* -------------------------------------      

   @ 45, 40 LABEL Lbl_EditVideo_Cassette ;
		VALUE 'Cassette:' ;
		WIDTH 90;
		FONT "ARIAL" SIZE 10 BOLD

   @ 25, 150 LABEL Lbl_EditVideo_LfdNr ;
		VALUE 'Lfd.Nr.' ;
		WIDTH 150;
		FONT "ARIAL" SIZE 09 

   @ 40, 150 TEXTBOX tbx_EditVideo_LfdNr ;
		WIDTH 040 ;
		FONT "ARIAL" SIZE 10 BOLD ;
      NUMERIC INPUTMASK '999'  
      

* -------------------------------------      

  @ 25, 210 LABEL Lbl_EditVideo_CassText ;
		VALUE 'Cassetten-Beschriftung' ;
		WIDTH 150;
		FONT "ARIAL" SIZE 09 

   @ 40, 210 TEXTBOX tbx_EditVideo_CassText ;
		WIDTH 270 ;
      MAXLENGTH   40 ;
		FONT "ARIAL" SIZE 10 BOLD 
      

* -------------------------------------      

  @ 25, 500 LABEL Lbl_EditVideo_Format ;
		VALUE 'Video-Format' ;
		WIDTH 150;
		FONT "ARIAL" SIZE 09 

	@ 040, 500 COMBOBOX cmb_EditVideo_Format ;
		WIDTH 100 HEIGHT 250;
      ITEMS format_types ;
      TOOLTIP "Auswahl des Videoformats bzw. des Cassetten-Typs" ;
		FONT "ARIAL" SIZE 10 BOLD

* -------------------------------------      

   @ 95, 40 LABEL Lbl_EditVideo_Quell ;
		VALUE 'Quellmaterial:' ;
		WIDTH 90;
		FONT "ARIAL" SIZE 10 BOLD

   @ 75, 150 LABEL Lbl_EditVideo_Datum ;
		VALUE 'Aufn.Datum' ;
		WIDTH 150;
		FONT "ARIAL" SIZE 09 

   @ 90, 150 TEXTBOX tbx_EditVideo_Datum ;
		WIDTH 080 ;
		FONT "ARIAL" SIZE 10 BOLD ;
		INPUTMASK '99.99.9999' ;
      RIGHTALIGN 
      
* -------------------------------------      

  @ 75, 250 LABEL Lbl_EditVideo_Szene ;
		VALUE 'Szene im Quellmaterial' ;
		WIDTH 150;
		FONT "ARIAL" SIZE 09 

   @ 90, 250 TEXTBOX tbx_EditVideo_Szene ;
		WIDTH 340 ;
      MAXLENGTH   44 ;
		FONT "ARIAL" SIZE 10 BOLD 
      

* -------------------------------------      

   @ 145, 40 LABEL Lbl_EditVideo_Bearb ;
		VALUE 'Bearbeitung:' ;
		WIDTH 90;
		FONT "ARIAL" SIZE 10 BOLD

   @ 125, 150 LABEL Lbl_EditVideo_Proj ;
		VALUE 'Projektbezeichnung' ;
		WIDTH 150;
		FONT "ARIAL" SIZE 09 

   @ 140, 150 TEXTBOX tbx_EditVideo_Proj ;
		WIDTH 435 ;
      MAXLENGTH   44 ;
		FONT "ARIAL" SIZE 10 BOLD 
      

* -------------------------------------      

   @ 195, 40 LABEL Lbl_EditVideo_Erg ;
		VALUE 'Ergebnis:' ;
		WIDTH 90;
		FONT "ARIAL" SIZE 10 BOLD

   @ 175, 150 LABEL Lbl_EditVideo_Titel ;
		VALUE 'Titel des Video-Clips' ;
		WIDTH 150;
		FONT "ARIAL" SIZE 09 

   @ 190, 150 TEXTBOX tbx_EditVideo_Titel ;
		WIDTH 435 ;
      MAXLENGTH   44 ;
		FONT "ARIAL" SIZE 10 BOLD 
      


     
* -------------------------------------      

		@ 250, 150 BUTTON Btn_EditSave ;
				CAPTION 'Datensatz speichern' ;
				PICTURE "Save" LEFT ;
				ACTION   (Save_MediaData(), Window_EditVideo.Release, VideoManager.Brs_VideoListe.Refresh) ;
				ToolTip "Datensatz speichern und Window schliessen";
				WIDTH 200 ;
				HEIGHT 40 ;
				FONT "ARIAL" SIZE 10 BOLD 
      
     

		@ 250, 385 BUTTON Btn_EditDupli ;
				CAPTION 'Neue Quell-Szene' ;
				PICTURE "Foto_Neu" LEFT ;
				ACTION   VIDEO_Dupli() ;
				ToolTip "Einen neuen Szenen-Datensatz erzeugen";
				WIDTH 200 ;
				HEIGHT 40 ;
				FONT "ARIAL" SIZE 10 BOLD 
      
     
    END WINDOW 

   Load_MediaData()    
    
   Window_EditVideo.Center

   Window_EditVideo.Activate
   
RETURN NIL
   

*----------------------------
FUNCTION Load_MediaData()
*----------------------------
   Window_EditVideo.tbx_EditVideo_LfdNr.value     := VIDEOS->Lfd_Nr    // Werte aus der Datenbank in die Controls laden
   Window_EditVideo.tbx_EditVideo_CassText.value  := VIDEOS->Cassette
   Cass_Text      := VIDEOS->Cassette
   Window_EditVideo.cmb_EditVideo_Format.value    := VIDEOS->(VAL(LEFT(FORMAT,1)))
   Cass_Formatindex    := VIDEOS->(VAL(LEFT(FORMAT,1)))
   Window_EditVideo.tbx_EditVideo_Datum.value     := VIDEOS->(DTOC(Datum))
   Window_EditVideo.tbx_EditVideo_Szene.value     := VIDEOS->Quellszene   
   Window_EditVideo.tbx_EditVideo_Proj.value      := VIDEOS->Projekt    
   Window_EditVideo.tbx_EditVideo_Titel.value     := VIDEOS->Titel    

RETURN NIL

*----------------------------
FUNCTION Save_MediaData()
*----------------------------
   VIDEOS->Lfd_Nr      := Window_EditVideo.tbx_EditVideo_LfdNr.value    // Werte aus den Controls in die Datenbank schreiben
   VIDEOS->Cassette    := Window_EditVideo.tbx_EditVideo_CassText.value
   VIDEOS->Format    := format_types[Window_EditVideo.cmb_EditVideo_Format.value]   
   VIDEOS->Datum       := CTOD(Window_EditVideo.tbx_EditVideo_Datum.value)
   VIDEOS->Quellszene   := Window_EditVideo.tbx_EditVideo_Szene.value
   VIDEOS->Projekt      := Window_EditVideo.tbx_EditVideo_Proj.value
   VIDEOS->Titel        := Window_EditVideo.tbx_EditVideo_Titel.value
   
   IF .NOT. (ALLTRIM(Cass_Text) == ALLTRIM(Window_EditVideo.tbx_EditVideo_CassText.value))   // Wurde die Cassettenbezeichnung gendert ?
      Vid_Sync(RECNO(), Window_EditVideo.tbx_EditVideo_LfdNr.value, Window_EditVideo.tbx_EditVideo_CassText.value)
   ENDIF

   IF Cass_Formatindex <> Window_EditVideo.cmb_EditVideo_Format.value   // Wurde das Cassettenformat gendert ?
      Format_Sync(RECNO(), Window_EditVideo.tbx_EditVideo_LfdNr.value, format_types[Window_EditVideo.cmb_EditVideo_Format.value]  )
   ENDIF


RETURN NIL



RETURN NIL



************************
FUNCTION VIDEO_Dupli()
************************

SELECT VIDEOS

last_nr		=	VIDEOS->LFD_NR
last_cass	=	VIDEOS->Cassette
last_date	=	VIDEOS->DATUM
last_proj	=	VIDEOS->PROJEKT
last_format	=	VIDEOS->FORMAT
last_szene  = 	'?? --  Original-Szene  -- ??'		&&-- Quell-Szene
last_clip   = 	'?? -- Titel Video-Clip -- ??'		&&-- Video-Clip Titel


APPEND BLANK
VIDEOS->LFD_NR 		:= last_nr		   &&-- letzte eingegebene Cassetten-Nr.
VIDEOS->CASSETTE  	:= last_cass		&&-- Cassetten-Bezeichnung
VIDEOS->DATUM  		:= last_date		&&-- Datum der letzten Original-Szene
VIDEOS->PROJEKT 	   := last_proj	 	&&-- Projekt-Name
VIDEOS->FORMAT 		:= last_format	&&-- zuletzt verwendetes Medien-Format
VIDEOS->QUELLSZENE 	:= last_szene		&&-- Dummy-Text
VIDEOS->TITEL     	:= last_clip		&&-- Dummy-Text

Load_MediaData()

RETURN



***************************************
FUNCTION Vid_Sync(v_rec,v_nr,v_text)   // RECNO(), Lfd_nr, Cassettenbeschriftung
***************************************

SELECT VIDEOS

IF TestModus
 MSGINFO("RECNO="+STR(v_rec)+CHR(13)+"Cass="+STR(v_nr)+CHR(13)+"Text="+v_text,"Vid_Sync()")
ENDIF

IF (v_nr > 0)

 REPLACE ALL VIDEOS->CASSETTE WITH v_text FOR (VIDEOS->Lfd_Nr == v_nr)
 
 IF TestModus
   MSGINFO("REPLACE wurde durchgefhrt:" +CRLF+CRLF+ v_text,"Vid_Sync()")
 ENDIF

 GO v_rec

 ENDIF

RETURN(.T.)
 
********************************************
FUNCTION Format_Sync(v_rec,v_nr,v_text)   // RECNO(), Lfd_nr, Formatbezeichnung
********************************************

SELECT VIDEOS

IF (v_nr > 0)

 REPLACE ALL VIDEOS->FORMAT WITH v_text FOR (VIDEOS->Lfd_Nr == v_nr)
 
 IF TestModus
   MSGINFO("REPLACE wurde durchgefhrt:" +CRLF+CRLF+ v_text,"Format_Sync()")
 ENDIF

 GO v_rec

 ENDIF

RETURN(.T.)
 
 
 