#include <hmg.ch>

DECLARE WINDOW VideoManager



*----------------------------------
FUNCTION Print_CassettenLabel()
*----------------------------------
   
	lPrintAccept   := PreparePrinter()

	If lPrintAccept == .T.
		Print_Label()
	EndIf

RETURN NIL




*------------------------
FUNCTION Print_Label()
*------------------------

SELECT VIDEOS
cass_titel	 = VIDEOS->Cassette			&&-- Bezeichnung der Cassette
cass_format = VIDEOS->Format			&&-- Bezeichung des Cassetten-Typs/Formats
cass_nummer = VIDEOS->Lfd_Nr				&&-- Nummer der Cassette

SET ORDER TO 1                &&--->>>    Index = Lfd-Nr + Datum

LOCATE FOR Lfd_Nr=cass_nummer    // auf ersten Datensatz dieser Cassette positionieren
IF EOF()
 MSGINFO("Cassette Nr. "+ALLTRIM(STR(cass_nummer))+" nicht gefunden !","Cassetten-Nummer suchen")
 RETURN
ENDIF

*----------------

SELECT LABEL

LOCATE FOR Format=cass_format
IF EOF()
 MSGINFO("Cassetten-Typ "+cass_format+" nicht gefunden !"+CHR(13)+CHR(13)+"--> Format 'Mini-DV' wird verwendet !!","Label-Datenbank")
 hoehe		   := 48
 breite		:= 67
 feld_1		:= 12
 lasche		:= 13
ELSE     // aus Datenbank holen
 hoehe		   := LABEL->Hoehe_mm
 breite		:= LABEL->Breite_mm
 feld_1		:= LABEL->Feld_1_mm
 lasche		:= LABEL->Lasche_mm
ENDIF

 l_oben     = 030    // Seitenrand
 l_links    = 030    // Seitenrand
 l_rechts   = l_links + breite
 l_unten    = l_oben + hoehe + feld_1 + lasche
 l_lasche   = l_oben + lasche
 l_feld     = l_oben + lasche + feld_1

 titel_limit	= Titel_Char   // Zeichen-Limit
 titel_anz	= LEN(ALLTRIM(cass_titel))    // Anzahl Zeichen Cassettenbeschriftung
 text_anz	= Text_Char
 spacing	= LABEL->Abstand_mm	&&-- Zeilenabstand



* ------------------------------------------------
START PRINTDOC

START PRINTPAGE
* ------------------------------------------------


*-------- gesamte Umrandung -------------------------

@ l_oben,l_links  PRINT LINE 	TO l_oben,l_rechts      PENWIDTH 0.1	  && horizontal oben
@ l_oben,l_links  PRINT LINE 	TO l_unten,l_links      PENWIDTH 0.1	  && vertikal links
@ l_oben,l_rechts PRINT LINE 	TO l_unten,l_rechts		PENWIDTH 0.1	  && vertikal rechts
@ l_unten,l_links PRINT LINE 	TO l_unten,l_rechts		PENWIDTH 0.1	  && horizontal unten

*-------- Innen-Linien -------------------------

@ l_lasche,l_links PRINT LINE  TO l_lasche,l_rechts   PENWIDTH 0.1	  && horizontal Lasche
@ l_feld,l_links   PRINT LINE  TO l_feld,l_rechts    PENWIDTH 0.1	  && horizontal Feld


*-------- Beschriftung -------------------------

SELECT VIDEOS

tab_1 = l_links + 002        &&-- linker Schriftrand
tab_2 = l_links + 015        &&-- Strich fr Cass-Nr.
tab_3 = l_links + 017        &&-- Schriftrand fr Text


@ l_lasche,tab_2 PRINT LINE  TO l_feld,tab_2	PENWIDTH 0.1	  && vertikaler Strich fr Cass-Nr


line_1 = l_oben+(l_lasche-l_oben)  /2 - 002  	&&-- FONT  9 ist 3mm hoch !
line_2 = l_lasche+(l_feld-l_lasche)/2 - 003     	&&-- FONT 10 ist 5mm hoch !
line_3 = l_lasche+(l_feld-l_lasche)/2 - 002     	&&-- FONT  9 ist 3mm hoch !


@ line_1,tab_1 PRINT SUBSTR(cass_format,4,9)	      FONT "Arial" SIZE 12 BOLD 	&&-- Typ der Cassette
@ line_2,tab_1 PRINT LTRIM(STR(cass_nummer,4))	   FONT "Arial" SIZE 18 BOLD  	&&-- Nummer der Cassette
IF Titel_anz > Titel_Limit
   IF TestModus
    MSGINFO("Anzahl der Zeichen im Cassetten-Titel"+CRLF+"berschreitet das Limit: "+CRLF+CRLF+ "Titel = "+STR(Titel_anz,2)+ " Zeichen"+CRLF+ "Limit = "+STR(Titel_Limit,3)+ "Zeichen","Print_Label()")
   ENDIF
   @ line_3,tab_3 PRINT LEFT(cass_titel,titel_anz)    FONT "Arial" SIZE 10 BOLD  	&&-- Titel der Cassette -> kleinere Schrift
ELSE
   IF TestModus
    MSGINFO("Anzahl der Zeichen im Cassetten-Titel"+CRLF+"kleiner als Limit: "+CRLF+CRLF+ "Titel = "+STR(Titel_anz,2)+ " Zeichen"+CRLF+ "Limit = "+STR(Titel_Limit,3)+ "Zeichen","Print_Label()")
   ENDIF
   @ line_3,tab_3 PRINT LEFT(cass_titel,titel_anz)    FONT "Arial" SIZE 12 BOLD  	&&-- Titel der Cassette 
ENDIF
line = l_feld + 003


*-------- Inhalte auflisten  -------------------------


DO WHILE (Lfd_Nr == cass_nummer) .AND. .NOT. EOF()

  @ line,tab_1 PRINT DTOC(datum)		    	   FONT "Arial" SIZE 07
  @ line,tab_3 PRINT LEFT(QUELLSZENE,text_anz)  FONT "Arial" SIZE 07

  line = line + spacing
  SKIP

ENDDO



									
* ------------------------------------------------
END PRINTPAGE
	
END PRINTDOC

*----------------------------------------
SELECT VIDEOS

RETURN NIL
