
/***********************************************************************************
* Programm: VideoManager
*****************************
*
* Zweck: Verwalten des Quellmaterials und der bearbeiteten Szenen von Home-Videos
*
***********************************************************************************

 
************************************************************************************
*	V1.00: 	Erste lauffhige 16Bit Windows-Version eines MedienManagers (CDs .. Videos)
*	.........................
*	V1.06: 	Produktiv einsetzbare 16Bit-Version (bis Windows XP)
*	--------------------------------------------------------------------
*	V2.00:	Stabile 32-Bit Version des Programmes mit Harbour-MiniGui (HMG)
*	--------------------------------------------------------------------
*
*           
*           
*           
***********************************************************************************/




#include <minigui.ch>
#include <hmg.ch>

Function Main
   
   // Generelle Einstellungen
	SET CENTURY ON
	SET DELETED ON
	SET DATE TO German
	SET LANGUAGE TO GERMAN
   SET CODEPAGE TO GERMAN
	SET EPOCH TO 2000
	SET BROWSESYNC ON
	SET NAVIGATION EXTENDED
	SET INTERACTIVECLOSE QUERY MAIN
	SET FONT TO  "Arial", 09
	
	
 
// ############### PROGRAMM-Version #####################
   cVersion = "V2.00"
   cStand   = "03.11.2013"
// ############### PROGRAMM-Version #####################

   
// ------------ Datenbank-Treiber ----------
   REQUEST DBFNTX
   
   
   
// -------- Globale Variable -----------
   Filterbedingung     := SPACE(20)
   Filterbeschreibung   := ' ?? '
   FilterSumme        := 00
   FilterAnzahl       := 00
   
   lPrinterWahl   := .F.
   lPrintVorschau := .T.
   lAutoBackup   := .F.
      
   TestModus   := .F.
   
   Vid_Anz     :=  0
   Vid_AktRec  := 0
   Cass_Text        := '  '
   Cass_Formatindex   := 1
   
   
// ------------- Datenbank-Setup -----------
   
   InitDatabases()    

// ------------- Arrays initialisieren -----------

SELECT LABEL
f_anz = LABEL->(LASTREC() )

format_types    := ARRAY(f_anz)
GO TOP
DO WHILE .NOT. EOF()
 f_num = RECNO()
 format_types[f_num] = Format
 SKIP
ENDDO

   
// ------------- User-Interface Setup ---------
	
   Main_Window()
   
RETURN NIL


*#################### Hauptfenster aufbauen ####################
PROCEDURE Main_Window
*################################################################

   DEFINE WINDOW VideoManager          ;
		AT 0,0      ;
		WIDTH 1200  ;
		HEIGHT 750  ;
		TITLE 'VideoManager '+cVersion+'  -  Stand: ' + cStand   ;
      MAIN        ;
		FONT 'ARIAL' SIZE 9     ;  
		ON INIT   NIL ;
		ON RELEASE NIL ;
      ICON  'Movie'
   
// ----------------- ein minimales Popup-Menue einfgen  ----------------------
    
   DEFINE MAIN MENU 
   
 		POPUP "Datei" 
         SEPARATOR
         ITEM "Dateipflege"    ACTION  DateiPflege()
         ITEM "Backup"        ACTION  Backup()
         SEPARATOR
		 ITEM "Einstellungen"  ACTION Einstellungen()
         SEPARATOR
         ITEM "Beenden"       ACTION ThisWindow.Release
      END POPUP 
      
 		POPUP "Organisation" 
         SEPARATOR
         ITEM "Medienstatistik ermitteln" ACTION CountMedia()
         SEPARATOR
         ITEM "Cassettenformate festlegen"  ACTION Define_MediaFormat()
      END POPUP 
      
 		POPUP "Sonstiges" 
        SEPARATOR
         ITEM "Farbcodierungen ..."    ACTION GETCOLOR()
        SEPARATOR
         ITEM "Test-Modus EIN"    ACTION (TestModus:=.T.)
         ITEM "Test-Modus AUS"    ACTION (TestModus:=.F.)
        SEPARATOR
         ITEM " ..."    ACTION NIL
      END POPUP 
	END MENU // Main Menu

// --- Toolbar mit Grafiksymbolen am oberen Fensterrand

      DEFINE TOOLBAR ToolBar_1 BUTTONSIZE 200,30 RIGHTTEXT BORDER BOLD
      
			BUTTON Tool_01       ;
				CAPTION 'Neu ..' ;
				PICTURE "New" ;
				ACTION 	Create_Record() ;
				ToolTip "Neuen Datensatz erstellen" 
            
			BUTTON Tool_02       ;
				CAPTION 'Lschen' ;
				PICTURE "Delete" ;
				ACTION 	Delete_Record() ;
				ToolTip "Aktuellen Datensatz lschen" ;
            SEPARATOR
            
			BUTTON Tool_03       ;
				CAPTION 'Filtern' ;
				PICTURE "Filter" ;
				ACTION FILTER_VIDEO() ;
				ToolTip "Datenstze anhand bestimmter Kriterien auswhlen" 
            
			BUTTON Tool_04       ;
				CAPTION 'Freigabe' ;
				PICTURE "Find" ;
				ACTION FILTER_FREIGABE() ;
				ToolTip "Alle Datenstze wieder freigeben" ;
            SEPARATOR
            
			BUTTON Tool_05       ;
				CAPTION 'Bearbeiten' ;
				PICTURE "Edit" ;
				ACTION 	VIDEO_GUI() ;
				ToolTip "Aktuellen Datensatz zur Bearbeitung ffnen"
            
			BUTTON Tool_06       ;
				CAPTION 'Duplizieren' ;
				PICTURE "Foto_Neu" ;
				ACTION 	Ask_VIDEO_Dupli();
				ToolTip "Aktuellen Datensatz duplizieren und bearbeiten" ;
				SEPARATOR
            
            
			BUTTON Tool_07       ;
				CAPTION 'Cass. Label' ;
				PICTURE "Printer" ;
				ACTION Print_CassettenLabel() ;
				ToolTip "Label mit Inhaltsverzeichnis fr die Videocassette drucken" 
            
            
			BUTTON Tool_08       ;
				CAPTION 'Liste drucken' ;
				PICTURE "Printer" ;
				ACTION 	Print_SzenenListe() ;
				ToolTip "bersicht in Listenform ausdrucken" ;
				SEPARATOR
            
            
			BUTTON Tool_09       ;
				CAPTION 'Beenden' ;
				PICTURE "Beenden" ;
				ACTION ThisWindow.Release ;
            ToolTip "Das Programm beenden"
            
            
		END TOOLBAR
 

// ############################### Tabulatoren definieren  #########################################

      DEFINE TAB Tab_VideoManager ;
			AT 60,010 ;
			WIDTH 1190 ;
			HEIGHT 810 ;
         FONT 'Arial' SIZE 09  BOLD ;
			ON CHANGE TabChanged()

	//	============================= Seite 1: Projektbersicht in Listenform ===============================
	
		DEFINE PAGE ' bersicht Medien-Archiv '
         
	 
// Komplette Listendarstellung aller Datenstze
	  
      @ 040,020 BROWSE Brs_VideoListe ;
               WIDTH 1145 ;
               HEIGHT 550 ;
               HEADERS	{ 'Lfd. Nr.','Cassettenbeschriftung','Aufn.Datum','Szene im Quellmaterial','Projektbezeichnung','Titel des Video-Clips' } ;
               WIDTHS 	{    055   ,     210,             080,          260,               260,                260 } ;
               WORKAREA VIDEOS ;
               FIELDS 	{  'Lfd_Nr',    'Cassette',    'Datum',    'Quellszene',    'Projekt',    'Titel'  } ;
               JUSTIFY { BROWSE_JTFY_CENTER, BROWSE_JTFY_LEFT, BROWSE_JTFY_CENTER, BROWSE_JTFY_LEFT, BROWSE_JTFY_LEFT, BROWSE_JTFY_LEFT } ;
               FONT 'Arial' SIZE 09 BOLD;
               ON CHANGE 	NIL	 ;	
               ON DBLCLICK	VIDEO_GUI() ;   // Aufruf des Editier-Windows
               ON HEADCLICK  {  { || SortVideo(1) } , { || SortVideo(2) } , { || SortVideo(3) } , { || SortVideo(4) } , { || SortVideo(5) } , { || SortVideo(6) }   } 

		END PAGE
		
	//	============================= Seite 2: Detail-Daten ===============================
			
		DEFINE PAGE '  Medien-Details  '
      
      
         DEFINE TREE Video_Tree   AT 40,20 WIDTH 1145 HEIGHT 550 VALUE 1 ;
         FONT 'ARIAL' SIZE 10  ;
         NODEIMAGES { 'Filmspule' , 'Filmspule' };    // Default-ICONs fr Node closed/open
         ITEMIMAGES { 'Filmspule' , 'Filmspule' }     // Default-ICONs fr ITEM unselected/selected
         
         VideoManager.Video_Tree.FONTBOLD := .T.


         NODE 'Cassette No. ???' IMAGES {'Film_Reel.png'}
            TREEITEM 'Datum 1 - Originalszene 1' 
            TREEITEM 'Datum 2 - Originalszene 2' 
            TREEITEM 'Datum 3 - Originalszene 3' 
			END NODE


         END TREE
      
      
		END PAGE
					
    END TAB

 //	============================= Ende der Tabulatoren ===============================
 
 
 
 // ------ Status-Bar definieren ---------------------------------
 
      DEFINE STATUSBAR FONT 'Verdana' SIZE 8   
			STATUSITEM "  Copyright:   Richard Schmidt  1996-2013  -  Alle Rechte vorbehalten"     WIDTH 400 
			DATE                    WIDTH 100
			CLOCK                   WIDTH 100
		END STATUSBAR
   
	END WINDOW
   
   
	CENTER WINDOW VideoManager
	ACTIVATE WINDOW VideoManager

   
Return
